//+------------------------------------------------------------------+
//|                                                     AutoNews.mq4 |
//|                                   Copyright 2014, Gnutov Vitaliy |
//|                                                gnutovv@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, Gnutov Vitaliy"
#property link      "gnutovv@gmail.com"
#property version   "1.00"
#property strict
//--- input parameters
input datetime don; //     
input double   lot; //  
input int      tp=15; //TakeProfit
input int      sl=15; //StopLoss
datetime openorder;
datetime closeorder;
bool flag;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   printf("    "+TimeToStr(TimeCurrent())+".   : "+TimeToStr(don));
   openorder=don-3*60; //        
   flag=true;
   closeorder=don+5*60; //         
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   flag=false;
   openorder=0;
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   if(flag && TimeCurrent()>=openorder) //         10    
     {
      flag=false;
      OrderSend(Symbol(),OP_BUYSTOP,lot,Ask+10*Point,3,Bid-8*Point,Ask+tp*Point,"BuyStop",0,0,clrGreen);
      OrderSend(Symbol(),OP_SELLSTOP,lot,Bid-10*Point,3,Ask+8*Point,Bid-tp*Point,"SellStop",0,0,clrRed);
     }

   if(TimeCurrent()>=closeorder && OrdersTotal()!=(-1)) //   
     {
      int slippage=3;
      for(int i=OrdersTotal()-1; i>=0; i--)
        {
         if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) break;
         if(OrderType()==OP_BUYSTOP  ) OrderDelete(OrderTicket());
         if(OrderType()==OP_SELLSTOP ) OrderDelete(OrderTicket());
         if(OrderType()==OP_BUYLIMIT ) OrderDelete(OrderTicket());
         if(OrderType()==OP_SELLLIMIT) OrderDelete(OrderTicket());
        }
     }

  }
//+------------------------------------------------------------------+
